n=50;
L=1.0;
u0=0;
u1=-1;
h=L/(n-1);

x=[0:h:L]';
a=zeros(n,n);
f=zeros(n,1);
a(1,1) =-2;
a(1,2)=1;

for i=2:n-1
    a(i,i)=a(1,1);
    a(i,i-1) = 1;
    a(i,i+1) = 1;
end
a(n,n) = a(1,1);
a(n,n-1)=1;

f=-ones(n,1)*h^2;

%Boundary condition
a(1,1)=1e20;
a(n,n)=1e20;
f(1)=u0*1e20;
f(n)=u1*1e20;
% exact solution
%y=inv(a)*f;
cc=u0;
bb=u1-cc+0.5;
y=-0.5*x.^2+bb*x+cc;
figure(1)
hold off
h=plot(y,x,'b.');
set(h,'Markersize',15);

d=diag(a);
b=ones(n,1);
c=b;
% LU factorization
[alf,bet]=lu_tri(d,b,c);
% Forward substitution
z=forw_tri(f,bet);
% Back substitution
y_b=back_tri(z,alf,c);
hold on
h=plot(y_b,x,'g');
set(h,'Linewidth',2);

% Shooting method
niter=4
u2=zeros(niter,1);
q=zeros(niter,1);
% first guess
u_0=[u0 q(1)]';
[x,u]=ode45(@dudy,x,u_0);
plot(u(:,1),x,'c');
u2(1)=u(n,1);
% second guess
q(2)=1;
u_0=[u0 q(2)]';
[x,u]=ode45(@dudy,x,u_0);
plot(u(:,1),x,'m');
u2(2)=u(n,1);
% iteration loop
for i=3:niter
 q(i)=q(i-2) +(q(i-1)-q(i-2))*(u1-u2(i-2))/(u2(i-1)-u2(i-2));
 u_0=[u0 q(i)]';
 [x,u]=ode45(@dudy,x,u_0);
 plot(u(:,1),x,'r');
 u2(i)=u(n,1);
end    
grid on
h=legend('Exact','Finite Differences','1st Shot','2nd Shot','Iterations','Location','SouthWest');
set(h,'Fontsize',14);
h=ylabel('y');
set(h,'Fontsize',14);
h=xlabel('u');
set(h,'Fontsize',14);
h=title('Flow between plates - Shooting Method');
set(h,'Fontsize',16);
