n=50;
r1=1;
r2=4;
L=r2-r1
phi1=1;
phi2=64-24*log(4);
h=L/(n+1);

r=[r1+h:h:r2-h]';
a=zeros(n,n);
f=9*r*h^2;
a(1,1) =- 2;
a(1,2)=1;

for i=2:n-1
    a(i,i)=a(1,1);
    a(i,i-1) = 1;
    a(i,i+1) = 1;
end
a(n,n) = a(1,1);
a(n,n-1)=1;
% offf-diagonal terms
for i=1:n-1
    a(i,i+1)=a(i,i+1)+ 0.5*h/r(i);
    a(i+1,i)=a(i+1,i)- 0.5*h/r(i+1);
end
% right hand side
f(1)=f(1)-phi1+0.5*h*phi1/r(1);
f(n)=f(n)-phi2-0.5*h*phi2/r(n);

% exact solution
y=r.^3-24*log(r);
figure(1)
hold off
hn=plot(r,y,'r.');
set(hn,'Markersize',20);
hn=xlabel('R');
set(hn,'Fontsize',14);
hn=ylabel('\Phi(R)');
set(hn,'Fontsize',14);

d=diag(a);
for i=1:n-1
    b(i+1)=a(i+1,i);
    c(i)=a(i,i+1);
end

% LU factorization
[alf,bet]=lu_tri(d,b,c);
% Forward substitution
z=forw_tri(f,bet);
% Back substitution
y_b=back_tri(z,alf,c);
hold on
hn=plot(r,y_b,'b');
set(hn,'Linewidth',2);
hn=legend('Exact Solution','Finite Difference','Location','NorthWest');
set(hn,'Fontsize',14);
grid on
% U
figure(2)
u_e=3*r.^2-24./r;
hold off
hn=plot(r,u_e,'r.');
set(hn,'Markersize',15);
u_b=zeros(n,1);
u_b(1)=(y_b(2)-phi1)/(2*h);
u_b(n)=(phi2-y_b(n-1))/(2*h);
for i=2:n-1
    u_b(i)=(y_b(i+1)-y_b(i-1))/(2*h);
end
hold on
hn=plot(r,u_b,'b');
set(hn,'Linewidth',2);
hn=xlabel('R');
set(hn,'Fontsize',14);
hn=ylabel('U(R)');
set(hn,'Fontsize',14);
hn=legend('Exact Solution','Finite Difference','Location','NorthWest');
set(hn,'Fontsize',14);
grid on

